39. 组合总和
给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target 的不同组合数少于 150 个。
示例 1:
输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
示例 2:
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1
输出: []
提示:
- 1 <= candidates.length <= 30
- 2 <= candidates[i] <= 40
- candidates 的所有元素 互不相同
- 1 <= target <= 40
思路:(回溯)
主要思想还是回溯,只不过要注意以下点:
- 由于同一个数字可以重复使用,所以不需要设置是否已访问数组,只要所给数字不大于目标数target,就有可能被调用多次
- 这就要设置所选范围:
- 刚开始要把所给数组按升序排序
- 如果target比数组的第一个数都小,肯定不成立,直接返回
- 再去寻找最后界限,我是通过二分查找,找到最后一位不大于target的数的位置
- 如果每次递归都要从数组的第一个开始就会产生重复数组,这个就是处理一下顺序的问题,可以参考我的另一个博客47. 全排列 II,在这里只需从当前位置往后查找即可,不要回头查找。
代码:(Java)
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
public class combinationSum {
public static void main(String[] args) {
// TODO 自动生成的方法存根
int[] candidates = {2, 3, 6, 7};
int target = 7;
System.out.println(combinationSum(candidates, target));
}
public static List<List<Integer>> combinationSum(int[] candidates, int target) {
List<List<Integer>> combinations = new ArrayList<>();
List<Integer> combination = new ArrayList<>();
Arrays.sort(candidates);//先排序
if(candidates == null || candidates.length == 0 || target < candidates[0]) {
return combinations;
}
backtarcking(combinations, combination, candidates, 0, target);
return combinations;
}
private static void backtarcking(List<List<Integer>> combinations, List<Integer> combination, int[] candidates, int start, int target) {
// TODO 自动生成的方法存根
if(target == 0) {
combinations.add(new ArrayList<>(combination));
return;
}
if(target < candidates[start]) {
return;
}
int end = search(candidates, target);
for(int i = start; i <= end; i++) {
combination.add(candidates[i]);
backtarcking(combinations, combination, candidates, i, target - candidates[i]);
combination.remove(combination.size() - 1);//回溯
}
}
private static int search(int[] candidates, int target) {//二分查找
// TODO 自动生成的方法存根
int r = candidates.length - 1;
int l = 0;
while(l != r) {
int mid = l + (r - l) / 2;
if(candidates[mid] > target) {
r = mid - 1;
}else if(r == l + 1) {
break;
}else{
l = mid;
}
}
if(candidates[r] > target) {
r = l;
}
return r;
}
}
运行结果:
其他可用回溯方法的题目:
257. 二叉树的所有路径
79. 单词搜索
93. 复原 IP 地址
17. 电话号码的字母组合
46. 全排列
47. 全排列 II
注:仅供学参考!
题目来源:力扣